\section{Global Hashtags Follow-up with \approachName}

We propose to integrate \approachName into a decentralized architecture based on the following principles. 

\begin{itemize}
  \item Servers access a DHT (Distributed Hash Table) whenever a message is posted. A key is added for every hashtag contained in the message and the value contains the instance address, the timestamp of the last message (and potentially ids of recent message with this hashtag). The server adds the other registered peers to bootstrap its RPS (Random Peer Sampling) and start relaying hashtags with CHEPIN until there is no more activity on the instance and a timeout is reached.
  \item When a client wants to follow a hashtag, the server uses the instance addresses registered for the given key to bootstrap its RPS. It also uses the messages identifiers to populate its missing list and start using \approachName to asks for missing messages and relay existing messages.
  \item When the client stops following the hashtag, the server continues to participate in the dissemination until a certain timeout is reached.
\end{itemize}

While the DHT makes it possible to discover the content, using
\approachName enables a faster exchange of messages, a better
sharing of the effort and a better agility compared to a naive
solution based on subscribing to resources on servers only with
information given by the DHT.

\approachName demonstrates a meaningful compromise between
latency, bandwidth and agility according to users expectations,
current networks characteristics, and the viral property of some
hashtags.
